import astropy,os,scipy.interpolate,sys,scipy.signal
import numpy as np
from astropy.io import fits

import cosmics_ipython3 as cosmics

mask_int2=np.empty((4032,4096),dtype=np.int32)

os.system("ls p????[g,z,u,r]??????.fits > fits.lst")
os.system("ls p????bokr??????.fits >> fits.lst")

template=fits.open('decam-00425440-S18.fits')
template1=fits.open('p20150413_od.fits')

for line in open("fits.lst"):
    line=line.strip("\n")

    array, header = cosmics.fromfits(line)
    c = cosmics.cosmicsimage(array, gain=1.375, readnoise=7.3, sigclip = 5.0, sigfrac = 0.3, objlim = 5.0)
    c.run(maxiter = 3)

    cosmics.tofits("mask.fits", c.mask, header)

    filter=fits.getval(line,'FILTER',0)
    ccdnum=fits.getval(line,'CCD_NO',0)
    object=fits.open(line)
    bad=fits.open('bb_'+str(ccdnum)+'.fit')

    data=object[0].data
#    data1=template1[1].data
    data2=bad[0].data

    print(data.shape,c.mask.shape)

    mask=(data>=40000)
    mask2=(data2<=0.95)
    mask_int2=np.int32(1*(mask2 | mask | np.rot90(c.mask,1)[::-1,::1]))
#    hdu=fits.new_table(template[1].data)
#    hdu.header=template1[0].header
    prihdr=fits.Header()
    prihdr=template1[0].header
    prihdu=fits.PrimaryHDU(header=prihdr)
    hdu1=fits.PrimaryHDU(mask_int2)

    hdu1.header=template1[1].header
    hdu1.header['NAXIS1']=4096
    hdu1.header['NAXIS2']=4032
    hdu=fits.HDUList([prihdu])
#    hdu=fits.PrimaryHDU(mask_int2)
#    print(mask_int2.shape,template1[1].data.shape)
#    template1[1].data=template1[1].data#=np.rot90(mask_int2,1)
    hdu.append(hdu1)
#    hdu[1].header['BITPIX']=32
    hdu.writeto(line[:-5]+'_od.fits',clobber='Ture')
    os.system('rm -f '+line[:-5]+'_od.fits.fz')
    os.system('fpack '+line[:-5]+'_od.fits')

    sky_median=np.median(data)

    line1=line[:-5]+'_S.fits'

    template[0].header['DECALSDT']=(object[0].header['DATE-OBS']+'T'+object[0].header['TIME-OBS'],'legacypipe/runbrick.py run time')
    template[0].header['SKY_P0']=(sky_median,'sky')

    template.writeto(line1,clobber='Ture')

    object.close()
    template.close()
